gtkmm: Gtk::ListView Class Reference

gtkmm 4.12.0

Public Member Functions | Static Public Member Functions | Related Symbols | List of all members
Gtk::ListView Class Reference
Widgets | ListView Classes

A widget for displaying lists. More...

`#include <gtkmm/listview.h>`

Inheritance diagram for Gtk::ListView:
[legend]

## Public Member Functions
| ListView (ListView && src) noexcept
ListView & | operator= (ListView && src) noexcept
| ListView (const ListView &)=delete
ListView & | operator= (const ListView &)=delete
| ~ListView () noexcept override
GtkListView * | gobj ()
| Provides access to the underlying C GObject.
const GtkListView * | gobj () const
| Provides access to the underlying C GObject.
| ListView (const Glib::RefPtr< SelectionModel > & model={}, const Glib::RefPtr< ListItemFactory > & factory={})
Glib::RefPtr< SelectionModel > | get_model ()
| Gets the model that's currently used to read the items displayed.
Glib::RefPtr< const SelectionModel > | get_model () const
| Gets the model that's currently used to read the items displayed.
void | set_model (const Glib::RefPtr< SelectionModel > & model)
| Sets the model to use.
void | set_factory (const Glib::RefPtr< ListItemFactory > & factory)
| Sets the `Gtk::ListItemFactory` to use for populating list items.
Glib::RefPtr< ListItemFactory > | get_factory ()
| Gets the factory that's currently used to populate list items.
Glib::RefPtr< const ListItemFactory > | get_factory () const
| Gets the factory that's currently used to populate list items.
void | set_header_factory (const Glib::RefPtr< ListItemFactory > & factory)
| Sets the `Gtk::ListItemFactory` to use for populating the Gtk::ListHeader objects used in section headers.
Glib::RefPtr< ListItemFactory > | get_header_factory ()
| Gets the factory that's currently used to populate section headers.
Glib::RefPtr< const ListItemFactory > | get_header_factory () const
| Gets the factory that's currently used to populate section headers.
void | set_show_separators (bool show_separators=true)
| Sets whether the list box should show separators between rows.
bool | get_show_separators () const
| Returns whether the list box should show separators between rows.
void | set_single_click_activate (bool single_click_activate=true)
| Sets whether rows should be activated on single click and selected on hover.
bool | get_single_click_activate () const
| Returns whether rows will be activated on single click and selected on hover.
void | set_enable_rubberband (bool enable_rubberband=true)
| Sets whether selections can be changed by dragging with the mouse.
bool | get_enable_rubberband () const
| Returns whether rows can be selected by dragging with the mouse.
void | set_tab_behavior (ListTabBehavior tab_behavior)
| Sets the behavior of the `Tab` and `Shift`+`Tab` keys.
ListTabBehavior | get_tab_behavior () const
| Gets the behavior set for the `Tab` key.
void | scroll_to (guint pos, ListScrollFlags flags, const Glib::RefPtr< const ScrollInfo > & scroll)
| Scrolls to the item at the given position and performs the actions specified in flags.
Glib::PropertyProxy< Glib::RefPtr< ListItemFactory > > | property_factory ()
| Factory for populating list items.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< ListItemFactory > > | property_factory () const
| Factory for populating list items.
Glib::PropertyProxy< Glib::RefPtr< ListItemFactory > > | property_header_factory ()
| Factory for creating header widgets.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< ListItemFactory > > | property_header_factory () const
| Factory for creating header widgets.
Glib::PropertyProxy< Glib::RefPtr< SelectionModel > > | property_model ()
| Model for the items displayed.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< SelectionModel > > | property_model () const
| Model for the items displayed.
Glib::PropertyProxy< bool > | property_show_separators ()
| Show separators between rows.
Glib::PropertyProxy_ReadOnly< bool > | property_show_separators () const
| Show separators between rows.
Glib::PropertyProxy< bool > | property_single_click_activate ()
| Activate rows on single click and select them on hover.
Glib::PropertyProxy_ReadOnly< bool > | property_single_click_activate () const
| Activate rows on single click and select them on hover.
Glib::PropertyProxy< bool > | property_enable_rubberband ()
| Allow rubberband selection.
Glib::PropertyProxy_ReadOnly< bool > | property_enable_rubberband () const
| Allow rubberband selection.
Glib::PropertyProxy< ListTabBehavior > | property_tab_behavior ()
| Behavior of the `Tab` key.
Glib::PropertyProxy_ReadOnly< ListTabBehavior > | property_tab_behavior () const
| Behavior of the `Tab` key.
Glib::SignalProxy< void(guint)> | signal_activate ()
Public Member Functions inherited from Gtk::ListBase
| ListBase (ListBase && src) noexcept
ListBase & | operator= (ListBase && src) noexcept
| ListBase (const ListBase &)=delete
ListBase & | operator= (const ListBase &)=delete
| ~ListBase () noexcept override
GtkListBase * | gobj ()
| Provides access to the underlying C GObject.
const GtkListBase * | gobj () const
| Provides access to the underlying C GObject.
Public Member Functions inherited from Gtk::Widget
| Widget (Widget && src) noexcept
Widget & | operator= (Widget && src) noexcept
| Widget (const Widget &)=delete
Widget & | operator= (const Widget &)=delete
| ~Widget () noexcept override
| Destroys the widget.
GtkWidget * | gobj ()
| Provides access to the underlying C GObject.
const GtkWidget * | gobj () const
| Provides access to the underlying C GObject.
Glib::RefPtr< ConstraintTarget > | make_refptr_constrainttarget ()
| Converts this widget to a reference counted Gtk::ConstraintTarget.
Glib::RefPtr< const ConstraintTarget > | make_refptr_constrainttarget () const
| Converts this widget to a reference counted Gtk::ConstraintTarget.
void | show ()
| Flags a widget to be displayed.
void | hide ()
| Reverses the effects of show().
void | queue_draw ()
| Schedules this widget to be redrawn in the paint phase of the current or the next frame.
void | queue_resize ()
| Flags a widget to have its size renegotiated.
void | queue_allocate ()
| Flags the widget for a rerun of the size_allocate_vfunc() function.
void | size_allocate (const Allocation & allocation, int baseline)
| Allocates widget with a transformation that translates the origin to the position in allocation.
SizeRequestMode | get_request_mode () const
| Gets whether the widget prefers a height-for-width layout or a width-for-height layout.
void | measure (Orientation orientation, int for_size, int & minimum, int & natural, int & minimum_baseline, int & natural_baseline) const
| Measures widget in the orientation orientation and for the given for_size.
void | get_preferred_size (Requisition & minimum_size, Requisition & natural_size) const
| Retrieves the minimum and natural size of a widget, taking into account the widget’s preference for height-for-width management.
void | set_layout_manager (const Glib::RefPtr< LayoutManager > & layout_manager)
| Sets the layout manager delegate instance that provides an implementation for measuring and allocating the children of widget.
void | unset_layout_manager ()
| Undoes the effect of a previous call to set_layout_manager().
Glib::RefPtr< LayoutManager > | get_layout_manager ()
| Retrieves the layout manager used by widget.
Glib::RefPtr< const LayoutManager > | get_layout_manager () const
| Retrieves the layout manager used by widget.
bool | mnemonic_activate (bool group_cycling)
| Emits the signal_mnemonic_activate() signal.
bool | activate ()
| For widgets that can be “activated” (buttons, menu items, etc.) this function activates them.
void | set_can_focus (bool can_focus=true)
| Specifies whether the input focus can enter the widget or any of its children.
bool | get_can_focus () const
| Determines whether the input focus can enter widget or any of its children.
void | set_focusable (bool focusable=true)
| Specifies whether widget can own the input focus.
bool | get_focusable () const
| Determines whether widget can own the input focus.
bool | has_focus () const
| Determines if the widget has the global input focus.
bool | is_focus () const
| Determines if the widget is the focus widget within its toplevel.
bool | has_visible_focus () const
| Determines if the widget should show a visible indication that it has the global input focus.
bool | grab_focus ()
| Causes widget to have the keyboard focus for the `Gtk::Window` it's inside.
void | set_focus_on_click (bool focus_on_click=true)
| Sets whether the widget should grab focus when it is clicked with the mouse.
bool | get_focus_on_click () const
| Returns whether the widget should grab focus when it is clicked with the mouse.
void | set_can_target (bool can_target=true)
| Sets whether widget can be the target of pointer events.
bool | get_can_target () const
| Queries whether widget can be the target of pointer events.
bool | has_default () const
| Determines whether widget is the current default widget within its toplevel.
void | set_receives_default (bool receives_default=true)
| Specifies whether widget will be treated as the default widget within its toplevel when it has the focus, even if another widget is the default.
bool | get_receives_default () const
| Determines whether widget is always treated as the default widget within its toplevel when it has the focus, even if another widget is the default.
void | set_name (const Glib::ustring & name)
| Sets a widgets name.
void | unset_name ()
Glib::ustring | get_name () const
| Retrieves the name of a widget.
void | set_state_flags (StateFlags flags, bool clear=true)
| Turns on flag values in the current widget state.
void | unset_state_flags (StateFlags flags)
| Turns off flag values for the current widget state.
StateFlags | get_state_flags () const
| Returns the widget state as a flag set.
void | set_sensitive (bool sensitive=true)
| Sets the sensitivity of a widget.
bool | get_sensitive () const
| Returns the widget’s sensitivity.
bool | is_sensitive () const
| Returns the widget’s effective sensitivity.
void | set_visible (bool visible=true)
| Sets the visibility state of widget.
bool | get_visible () const
| Determines whether the widget is visible.
bool | is_visible () const
| Determines whether the widget and all its parents are marked as visible.
bool | is_drawable () const
| Determines whether widget can be drawn to.
bool | get_realized () const
| Determines whether widget is realized.
bool | get_mapped () const
| Whether the widget is mapped.
void | set_child_visible (bool visible=true)
| Sets whether widget should be mapped along with its parent.
bool | get_child_visible () const
| Gets the value set with set_child_visible().
int | get_allocated_width () const
| Returns the width that has currently been allocated to widget.
int | get_allocated_height () const
| Returns the height that has currently been allocated to widget.
int | get_allocated_baseline () const
| Returns the baseline that has currently been allocated to widget.
Allocation | get_allocation () const
| Retrieves the widget’s location.
std::optional< Gdk::Graphene::Rect > | compute_bounds (const Widget & target) const
| Computes the bounds for the widget in the coordinate space of target.
std::optional< Gdk::Graphene::Point > | compute_point (const Widget & target, const Gdk::Graphene::Point & point) const
| Translates the given point in the widget's coordinates to coordinates relative to target’s coordinate system.
int | get_width () const
| Returns the content width of the widget.
int | get_height () const
| Returns the content height of the widget.
int | get_baseline () const
| Returns the baseline that has currently been allocated to widget.
int | get_size (Orientation orientation) const
| Returns the content width or height of the widget.
Widget * | get_parent ()
| Returns the parent widget of widget.
const Widget * | get_parent () const
| Returns the parent widget of widget.
Root * | get_root ()
| Returns the `Gtk::Root` widget of widget.
const Root * | get_root () const
| Returns the `Gtk::Root` widget of widget.
Native * | get_native ()
| Returns the nearest `Gtk::Native` ancestor of widget.
const Native * | get_native () const
| Returns the nearest `Gtk::Native` ancestor of widget.
bool | child_focus (DirectionType direction)
| Called by widgets as the user moves around the window using keyboard shortcuts.
bool | keynav_failed (DirectionType direction)
| Emits the `::keynav-failed` signal on the widget.
void | error_bell ()
| Notifies the user about an input-related error on this widget.
void | set_size_request (int width=-1, int height=-1)
| Sets the minimum size of a widget.
void | get_size_request (int & width, int & height) const
| Gets the size request that was explicitly set for the widget using set_size_request().
void | set_opacity (double opacity)
| Request the widget to be rendered partially transparent.
double | get_opacity () const
| #Fetches the requested opacity for this widget.
void | set_overflow (Overflow overflow)
| Sets how widget treats content that is drawn outside the widget's content area.
Overflow | get_overflow () const
| Returns the widget’s overflow value.
Widget * | get_ancestor (GType widget_type)
| Gets the first ancestor of widget with type widget_type.
const Widget * | get_ancestor (GType widget_type) const
| Gets the first ancestor of widget with type widget_type.
int | get_scale_factor () const
| Retrieves the internal scale factor that maps from window coordinates to the actual device pixels.
Glib::RefPtr< Gdk::Display > | get_display ()
| Get the `Gdk::Display` for the toplevel window associated with this widget.
Glib::RefPtr< const Gdk::Display > | get_display () const
| Get the `Gdk::Display` for the toplevel window associated with this widget.
Glib::RefPtr< Settings > | get_settings ()
| Gets the settings object holding the settings used for this widget.
Glib::RefPtr< Gdk::Clipboard > | get_clipboard ()
| Gets the clipboard object for widget.
Glib::RefPtr< const Gdk::Clipboard > | get_clipboard () const
| Gets the clipboard object for widget.
Glib::RefPtr< Gdk::Clipboard > | get_primary_clipboard ()
| Gets the primary clipboard of widget.
Glib::RefPtr< const Gdk::Clipboard > | get_primary_clipboard () const
| Gets the primary clipboard of widget.
bool | get_hexpand () const
| Gets whether the widget would like any available extra horizontal space.
void | set_hexpand (bool expand=true)
| Sets whether the widget would like any available extra horizontal space.
bool | get_hexpand_set () const
| Gets whether set_hexpand() has been used to explicitly set the expand flag on this widget.
void | set_hexpand_set (bool set=true)
| Sets whether the hexpand flag will be used.
bool | get_vexpand () const
| Gets whether the widget would like any available extra vertical space.
void | set_vexpand (bool expand=true)
| Sets whether the widget would like any available extra vertical space.
bool | get_vexpand_set () const
| Gets whether set_vexpand() has been used to explicitly set the expand flag on this widget.
void | set_vexpand_set (bool set=true)
| Sets whether the vexpand flag will be used.
bool | compute_expand (Orientation orientation)
| Computes whether a container should give this widget extra space when possible.
void | set_expand (bool expand=true)
| Sets whether the widget would like any available extra space in both directions.
Align | get_halign () const
| Gets the horizontal alignment of widget.
void | set_halign (Align align)
| Sets the horizontal alignment of widget.
Align | get_valign () const
| Gets the vertical alignment of widget.
void | set_valign (Align align)
| Sets the vertical alignment of widget.
int | get_margin_start () const
| Gets the start margin of widget.
void | set_margin_start (int margin)
| Sets the start margin of widget.
int | get_margin_end () const
| Gets the end margin of widget.
void | set_margin_end (int margin)
| Sets the end margin of widget.
int | get_margin_top () const
| Gets the top margin of widget.
void | set_margin_top (int margin)
| Sets the top margin of widget.
int | get_margin_bottom () const
| Gets the bottom margin of widget.
void | set_margin_bottom (int margin)
| Sets the bottom margin of widget.
void | set_margin (int margin)
| Set all 4 margins to the same value.
bool | is_ancestor (Widget & ancestor) const
| Determines whether widget is somewhere inside ancestor, possibly with intermediate containers.
bool | translate_coordinates (Widget & dest_widget, double src_x, double src_y, double & dest_x, double & dest_y)
| Translate coordinates relative to src_widget’s allocation to coordinates relative to dest_widget’s allocations.
bool | contains (double x, double y) const
| Tests if the point at ( x, y) is contained in widget.
Widget * | pick (double x, double y, PickFlags flags=PickFlags::DEFAULT)
| Finds the descendant of widget closest to the point ( x, y).
const Widget * | pick (double x, double y, PickFlags flags=PickFlags::DEFAULT) const
| Finds the descendant of widget closest to the point ( x, y).
void | add_controller (const Glib::RefPtr< EventController > & controller)
| Adds controller to widget so that it will receive events.
void | remove_controller (const Glib::RefPtr< EventController > & controller)
| Removes controller from widget, so that it doesn't process events anymore.
Glib::RefPtr< Pango::Context > | create_pango_context ()
| Creates a new `Pango::Context` with the appropriate font map, font options, font description, and base direction for drawing text for this widget.
Glib::RefPtr< Pango::Context > | get_pango_context ()
| Gets a `Pango::Context` with the appropriate font map, font description, and base direction for this widget.
void | set_font_options (const Cairo::FontOptions & options)
| Sets the `cairo_font_options_t` used for Pango rendering in this widget.
void | unset_font_options ()
| Undoes the effect of previous calls to set_font_options().
Cairo::FontOptions | get_font_options () const
| Returns the `cairo_font_options_t` of widget.
Glib::RefPtr< Pango::Layout > | create_pango_layout (const Glib::ustring & text)
| Creates a new `Pango::Layout` with the appropriate font map, font description, and base direction for drawing text for this widget.
void | set_direction (TextDirection dir)
| Sets the reading direction on a particular widget.
TextDirection | get_direction () const
| Gets the reading direction for a particular widget.
void | set_cursor (const Glib::RefPtr< Gdk::Cursor > & cursor)
| Sets the cursor to be shown when pointer devices point towards widget.
void | set_cursor (const Glib::ustring & name={})
| Sets a named cursor to be shown when pointer devices point towards the widget.
Glib::RefPtr< Gdk::Cursor > | get_cursor ()
| Queries the cursor set on widget.
Glib::RefPtr< const Gdk::Cursor > | get_cursor () const
| Queries the cursor set on widget.
std::vector< Widget * > | list_mnemonic_labels ()
| Returns the widgets for which this widget is the target of a mnemonic.
std::vector< const Widget * > | list_mnemonic_labels () const
| Returns the widgets for which this widget is the target of a mnemonic.
void | add_mnemonic_label (Widget & label)
| Adds a widget to the list of mnemonic labels for this widget.
void | remove_mnemonic_label (Widget & label)
| Removes a widget from the list of mnemonic labels for this widget.
bool | drag_check_threshold (int start_x, int start_y, int current_x, int current_y)
| Checks to see if a drag movement has passed the GTK drag threshold.
Glib::RefPtr< Gdk::FrameClock > | get_frame_clock ()
| Obtains the frame clock for a widget.
Glib::RefPtr< const Gdk::FrameClock > | get_frame_clock () const
| Obtains the frame clock for a widget.
void | set_parent (Widget & parent)
| Sets parent as the parent widget of widget.
void | unparent ()
| Dissociate widget from its parent.
void | map ()
| Causes a widget to be mapped if it isn’t already.
void | unmap ()
| Causes a widget to be unmapped if it’s currently mapped.
void | trigger_tooltip_query ()
| Triggers a tooltip query on the display where the toplevel of widget is located.
void | set_tooltip_text (const Glib::ustring & text)
| Sets text as the contents of the tooltip.
Glib::ustring | get_tooltip_text () const
| Gets the contents of the tooltip for widget.
void | set_tooltip_markup (const Glib::ustring & markup)
| Sets markup as the contents of the tooltip, which is marked up with the Pango text markup language.
Glib::ustring | get_tooltip_markup () const
| Gets the contents of the tooltip for widget.
void | set_has_tooltip (bool has_tooltip=TRUE)
| Sets the `has-tooltip` property on widget to has_tooltip.
bool | get_has_tooltip () const
| Returns the current value of the `has-tooltip` property.
bool | in_destruction () const
| Returns whether the widget is currently being destroyed.
Glib::RefPtr< StyleContext > | get_style_context ()
| Returns the style context associated to widget.
Glib::RefPtr< const StyleContext > | get_style_context () const
| Returns the style context associated to widget.
guint | add_tick_callback (const SlotTick & slot)
| Queues an animation frame update and adds a callback to be called before each frame.
void | remove_tick_callback (guint id)
| Removes a tick callback previously registered with add_tick_callback().
void | insert_action_group (const Glib::ustring & name, const Glib::RefPtr< Gio::ActionGroup > & group)
| Inserts group into widget.
void | remove_action_group (const Glib::ustring & name)
| Removes a group from the widget.
bool | activate_action (const Glib::ustring & name, const Glib::VariantBase & args={})
| Looks up the action in the action groups associated with the widget and its ancestors, and activates it.
void | activate_default ()
| Activates the `default.activate` action from widget.
void | set_font_map (const Glib::RefPtr< Pango::FontMap > & font_map)
| Sets the font map to use for Pango rendering.
Glib::RefPtr< Pango::FontMap > | get_font_map ()
| Gets the font map of widget.
Glib::RefPtr< const Pango::FontMap > | get_font_map () const
| Gets the font map of widget.
Widget * | get_first_child ()
| Returns the widget’s first child.
const Widget * | get_first_child () const
| Returns the widget’s first child.
Widget * | get_last_child ()
| Returns the widget’s last child.
const Widget * | get_last_child () const
| Returns the widget’s last child.
Widget * | get_next_sibling ()
| Returns the widget’s next sibling.
const Widget * | get_next_sibling () const
| Returns the widget’s next sibling.
Widget * | get_prev_sibling ()
| Returns the widget’s previous sibling.
const Widget * | get_prev_sibling () const
| Returns the widget’s previous sibling.
Glib::RefPtr< Gio::ListModel > | observe_children ()
| Returns a `Gio::ListModel` to track the children of widget.
Glib::RefPtr< const Gio::ListModel > | observe_children () const
| Returns a `Gio::ListModel` to track the children of widget.
Glib::RefPtr< Gio::ListModel > | observe_controllers ()
| Returns a `Gio::ListModel` to track the Gtk::EventControllers of widget.
Glib::RefPtr< const Gio::ListModel > | observe_controllers () const
| Returns a `Gio::ListModel` to track the Gtk::EventControllers of widget.
void | insert_after (Widget & parent, const Widget & previous_sibling)
| Inserts the Widget into the child widget list of parent after previous_sibling.
void | insert_before (Widget & parent, const Widget & next_sibling)
| Inserts the Widget into the child widget list of parent before next_sibling.
void | insert_at_start (Widget & parent)
| Inserts the Widget at the beginning of the child widget list of parent.
void | insert_at_end (Widget & parent)
| Inserts the Widget at the end of the child widget list of parent.
void | snapshot_child (Widget & child, const Glib::RefPtr< Gtk::Snapshot > & snapshot)
| Snapshot the a child of widget.
bool | should_layout () const
| Returns whether widget should contribute to the measuring and allocation of its parent.
Glib::ustring | get_css_name () const
| Returns the CSS name that is used for self.
void | add_css_class (const Glib::ustring & css_class)
| Adds a style class to widget.
void | remove_css_class (const Glib::ustring & css_class)
| Removes a style from widget.
bool | has_css_class (const Glib::ustring & css_class) const
| Returns whether css_class is currently applied to widget.
std::vector< Glib::ustring > | get_css_classes () const
| Returns the list of style classes applied to widget.
void | set_css_classes (const std::vector< Glib::ustring > & classes)
| Clear all style classes applied to widget and replace them with classes.
Gdk::RGBA | get_color () const
| Gets the current foreground color for the widget's CSS style.
Glib::SignalProxy< void()> | signal_show ()
Glib::SignalProxy< void()> | signal_hide ()
Glib::SignalProxy< void()> | signal_map ()
| Emitted on mapping of a widget to the screen.
Glib::SignalProxy< void()> | signal_unmap ()
Glib::SignalProxy< void()> | signal_realize ()
| Emitted on realization of a widget.
Glib::SignalProxy< void()> | signal_unrealize ()
Glib::SignalProxy< void(Gtk::StateFlags)> | signal_state_flags_changed ()
Glib::SignalProxy< void(TextDirection)> | signal_direction_changed ()
Glib::SignalProxy< bool(bool)> | signal_mnemonic_activate ()
Glib::SignalProxy< void()> | signal_destroy ()
| Emitted during the dispose phase.
Glib::SignalProxy< bool(int, int, bool, const Glib::RefPtr< Tooltip > &)> | signal_query_tooltip ()
Glib::PropertyProxy< Glib::ustring > | property_name ()
| The name of the widget.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| The name of the widget.
Glib::PropertyProxy_ReadOnly< Widget * > | property_parent () const
| The parent widget of this widget.
Glib::PropertyProxy_ReadOnly< Root * > | property_root () const
| The `Gtk::Root` widget of the widget tree containing this widget.
Glib::PropertyProxy< int > | property_width_request ()
| Override for width request of the widget.
Glib::PropertyProxy_ReadOnly< int > | property_width_request () const
| Override for width request of the widget.
Glib::PropertyProxy< int > | property_height_request ()
| Override for height request of the widget.
Glib::PropertyProxy_ReadOnly< int > | property_height_request () const
| Override for height request of the widget.
Glib::PropertyProxy< bool > | property_visible ()
| Whether the widget is visible.
Glib::PropertyProxy_ReadOnly< bool > | property_visible () const
| Whether the widget is visible.
Glib::PropertyProxy< bool > | property_sensitive ()
| Whether the widget responds to input.
Glib::PropertyProxy_ReadOnly< bool > | property_sensitive () const
| Whether the widget responds to input.
Glib::PropertyProxy< bool > | property_can_focus ()
| Whether the widget or any of its descendents can accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_can_focus () const
| Whether the widget or any of its descendents can accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_has_focus () const
| Whether the widget has the input focus.
Glib::PropertyProxy< bool > | property_can_target ()
| Whether the widget can receive pointer events.
Glib::PropertyProxy_ReadOnly< bool > | property_can_target () const
| Whether the widget can receive pointer events.
Glib::PropertyProxy< bool > | property_focus_on_click ()
| Whether the widget should grab focus when it is clicked with the mouse.
Glib::PropertyProxy_ReadOnly< bool > | property_focus_on_click () const
| Whether the widget should grab focus when it is clicked with the mouse.
Glib::PropertyProxy< bool > | property_focusable ()
| Whether this widget itself will accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_focusable () const
| Whether this widget itself will accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_has_default () const
| Whether the widget is the default widget.
Glib::PropertyProxy< bool > | property_receives_default ()
| Whether the widget will receive the default action when it is focused.
Glib::PropertyProxy_ReadOnly< bool > | property_receives_default () const
| Whether the widget will receive the default action when it is focused.
Glib::PropertyProxy< Glib::RefPtr< Gdk::Cursor > > | property_cursor ()
| The cursor used by widget.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::Cursor > > | property_cursor () const
| The cursor used by widget.
Glib::PropertyProxy< bool > | property_has_tooltip ()
| Enables or disables the emission of the signal_query_tooltip() signal on widget.
Glib::PropertyProxy_ReadOnly< bool > | property_has_tooltip () const
| Enables or disables the emission of the signal_query_tooltip() signal on widget.
Glib::PropertyProxy< Glib::ustring > | property_tooltip_markup ()
| Sets the text of tooltip to be the given string, which is marked up with Pango markup.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_markup () const
| Sets the text of tooltip to be the given string, which is marked up with Pango markup.
Glib::PropertyProxy< Glib::ustring > | property_tooltip_text ()
| Sets the text of tooltip to be the given string.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_text () const
| Sets the text of tooltip to be the given string.
Glib::PropertyProxy< Align > | property_halign ()
| How to distribute horizontal space if widget gets extra space.
Glib::PropertyProxy_ReadOnly< Align > | property_halign () const
| How to distribute horizontal space if widget gets extra space.
Glib::PropertyProxy< Align > | property_valign ()
| How to distribute vertical space if widget gets extra space.
Glib::PropertyProxy_ReadOnly< Align > | property_valign () const
| How to distribute vertical space if widget gets extra space.
Glib::PropertyProxy< int > | property_margin_start ()
| Margin on start of widget, horizontally.
Glib::PropertyProxy_ReadOnly< int > | property_margin_start () const
| Margin on start of widget, horizontally.
Glib::PropertyProxy< int > | property_margin_end ()
| Margin on end of widget, horizontally.
Glib::PropertyProxy_ReadOnly< int > | property_margin_end () const
| Margin on end of widget, horizontally.
Glib::PropertyProxy< int > | property_margin_top ()
| Margin on top side of widget.
Glib::PropertyProxy_ReadOnly< int > | property_margin_top () const
| Margin on top side of widget.
Glib::PropertyProxy< int > | property_margin_bottom ()
| Margin on bottom side of widget.
Glib::PropertyProxy_ReadOnly< int > | property_margin_bottom () const
| Margin on bottom side of widget.
Glib::PropertyProxy< bool > | property_hexpand ()
| Whether to expand horizontally.
Glib::PropertyProxy_ReadOnly< bool > | property_hexpand () const
| Whether to expand horizontally.
Glib::PropertyProxy< bool > | property_hexpand_set ()
| Whether to use the `hexpand` property.
Glib::PropertyProxy_ReadOnly< bool > | property_hexpand_set () const
| Whether to use the `hexpand` property.
Glib::PropertyProxy< bool > | property_vexpand ()
| Whether to expand vertically.
Glib::PropertyProxy_ReadOnly< bool > | property_vexpand () const
| Whether to expand vertically.
Glib::PropertyProxy< bool > | property_vexpand_set ()
| Whether to use the `vexpand` property.
Glib::PropertyProxy_ReadOnly< bool > | property_vexpand_set () const
| Whether to use the `vexpand` property.
Glib::PropertyProxy< double > | property_opacity ()
| The requested opacity of the widget.
Glib::PropertyProxy_ReadOnly< double > | property_opacity () const
| The requested opacity of the widget.
Glib::PropertyProxy< Overflow > | property_overflow ()
| How content outside the widget's content area is treated.
Glib::PropertyProxy_ReadOnly< Overflow > | property_overflow () const
| How content outside the widget's content area is treated.
Glib::PropertyProxy_ReadOnly< int > | property_scale_factor () const
| The scale factor of the widget.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_css_name () const
| The name of this widget in the CSS tree.
Glib::PropertyProxy< std::vector< Glib::ustring > > | property_css_classes ()
| A list of css classes applied to this widget.
Glib::PropertyProxy_ReadOnly< std::vector< Glib::ustring > > | property_css_classes () const
| A list of css classes applied to this widget.
Glib::PropertyProxy< Glib::RefPtr< LayoutManager > > | property_layout_manager ()
| The `Gtk::LayoutManager` instance to use to compute the preferred size of the widget, and allocate its children.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< LayoutManager > > | property_layout_manager () const
| The `Gtk::LayoutManager` instance to use to compute the preferred size of the widget, and allocate its children.
Public Member Functions inherited from Gtk::Object
| Object (Object && src) noexcept
Object & | operator= (Object && src) noexcept
| ~Object () noexcept override
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from Gtk::Accessible
| Accessible (Accessible && src) noexcept
Accessible & | operator= (Accessible && src) noexcept
| ~Accessible () noexcept override
GtkAccessible * | gobj ()
| Provides access to the underlying C GObject.
const GtkAccessible * | gobj () const
| Provides access to the underlying C GObject.
Glib::RefPtr< ATContext > | get_at_context ()
| Retrieves the accessible implementation for the given `Gtk::Accessible`.
Glib::RefPtr< const ATContext > | get_at_context () const
| Retrieves the accessible implementation for the given `Gtk::Accessible`.
bool | get_platform_state (PlatformState state) const
| Query a platform state, such as focus.
Glib::RefPtr< Accessible > | get_accessible_parent ()
| Retrieves the accessible parent for an accessible object.
Glib::RefPtr< const Accessible > | get_accessible_parent () const
| Retrieves the accessible parent for an accessible object.
void | set_accessible_parent (const Glib::RefPtr< Accessible > & parent, const Glib::RefPtr< Accessible > & next_sibling)
| Sets the parent and sibling of an accessible object.
Glib::RefPtr< Accessible > | get_first_accessible_child ()
| Retrieves the first accessible child of an accessible object.
Glib::RefPtr< const Accessible > | get_first_accessible_child () const
| Retrieves the first accessible child of an accessible object.
Glib::RefPtr< Accessible > | get_next_accessible_sibling ()
| Retrieves the next accessible sibling of an accessible object.
Glib::RefPtr< const Accessible > | get_next_accessible_sibling () const
| Retrieves the next accessible sibling of an accessible object.
void | update_next_accessible_sibling (const Glib::RefPtr< Accessible > & new_sibling)
| Updates the next accessible sibling of self.
bool | get_bounds (int & x, int & y, int & width, int & height) const
| Queries the coordinates and dimensions of this accessible.
Role | get_accessible_role () const
| Retrieves the accessible role of an accessible object.
void | update_state (State state, const Glib::ValueBase & value)
| Updates an accessible state.
void | update_property (Property property, const Glib::ValueBase & value)
| Updates an accessible property.
void | update_relation (Relation relation, const Glib::ValueBase & value)
| Updates an accessible relation.
void | reset_state (State state)
| Resets the accessible state to its default value.
void | reset_property (Property property)
| Resets the accessible property to its default value.
void | reset_relation (Relation relation)
| Resets the accessible relation to its default value.
Glib::PropertyProxy< Role > | property_accessible_role ()
| The accessible role of the given `Gtk::Accessible` implementation.
Glib::PropertyProxy_ReadOnly< Role > | property_accessible_role () const
| The accessible role of the given `Gtk::Accessible` implementation.
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const
Public Member Functions inherited from Gtk::Buildable
| Buildable (Buildable && src) noexcept
Buildable & | operator= (Buildable && src) noexcept
| ~Buildable () noexcept override
GtkBuildable * | gobj ()
| Provides access to the underlying C GObject.
const GtkBuildable * | gobj () const
| Provides access to the underlying C GObject.
Glib::ustring | get_buildable_id () const
| Gets the ID of the buildable object.
Public Member Functions inherited from Gtk::ConstraintTarget
| ConstraintTarget (ConstraintTarget && src) noexcept
ConstraintTarget & | operator= (ConstraintTarget && src) noexcept
| ~ConstraintTarget () noexcept override
GtkConstraintTarget * | gobj ()
| Provides access to the underlying C GObject.
const GtkConstraintTarget * | gobj () const
| Provides access to the underlying C GObject.
Public Member Functions inherited from Gtk::Orientable
| Orientable (Orientable && src) noexcept
Orientable & | operator= (Orientable && src) noexcept
| ~Orientable () noexcept override
GtkOrientable * | gobj ()
| Provides access to the underlying C GObject.
const GtkOrientable * | gobj () const
| Provides access to the underlying C GObject.
void | set_orientation (Orientation orientation)
| Sets the orientation of the orientable.
Orientation | get_orientation () const
| Retrieves the orientation of the orientable.
Glib::PropertyProxy< Orientation > | property_orientation ()
| The orientation of the orientable.
Glib::PropertyProxy_ReadOnly< Orientation > | property_orientation () const
| The orientation of the orientable.
Public Member Functions inherited from Gtk::Scrollable
| Scrollable (Scrollable && src) noexcept
Scrollable & | operator= (Scrollable && src) noexcept
| ~Scrollable () noexcept override
GtkScrollable * | gobj ()
| Provides access to the underlying C GObject.
const GtkScrollable * | gobj () const
| Provides access to the underlying C GObject.
Glib::RefPtr< Adjustment > | get_hadjustment ()
| Retrieves the `Gtk::Adjustment` used for horizontal scrolling.
Glib::RefPtr< const Adjustment > | get_hadjustment () const
| Retrieves the `Gtk::Adjustment` used for horizontal scrolling.
void | set_hadjustment (const Glib::RefPtr< Adjustment > & hadjustment)
| Sets the horizontal adjustment of the `Gtk::Scrollable`.
void | unset_hadjustment ()
| This method removes the hadjustment.
Glib::RefPtr< Adjustment > | get_vadjustment ()
| Retrieves the `Gtk::Adjustment` used for vertical scrolling.
Glib::RefPtr< const Adjustment > | get_vadjustment () const
| Retrieves the `Gtk::Adjustment` used for vertical scrolling.
void | set_vadjustment (const Glib::RefPtr< Adjustment > & vadjustment)
| Sets the vertical adjustment of the `Gtk::Scrollable`.
void | unset_vadjustment ()
| This method removes the vadjustment.
Policy | get_hscroll_policy () const
| Gets the horizontal `Gtk::Scrollable::Policy`.
void | set_hscroll_policy (Policy policy)
| Sets the `Gtk::Scrollable::Policy`.
Policy | get_vscroll_policy () const
| Gets the vertical `Gtk::Scrollable::Policy`.
void | set_vscroll_policy (Policy policy)
| Sets the `Gtk::Scrollable::Policy`.
bool | get_border (Border & border) const
| Returns the size of a non-scrolling border around the outside of the scrollable.
Glib::PropertyProxy< Glib::RefPtr< Adjustment > > | property_hadjustment ()
| Horizontal `Gtk::Adjustment` of the scrollable widget.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Adjustment > > | property_hadjustment () const
| Horizontal `Gtk::Adjustment` of the scrollable widget.
Glib::PropertyProxy< Glib::RefPtr< Adjustment > > | property_vadjustment ()
| Vertical `Gtk::Adjustment` of the scrollable widget.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Adjustment > > | property_vadjustment () const
| Vertical `Gtk::Adjustment` of the scrollable widget.
Glib::PropertyProxy< Policy > | property_hscroll_policy ()
| Determines when horizontal scrolling should start.
Glib::PropertyProxy_ReadOnly< Policy > | property_hscroll_policy () const
| Determines when horizontal scrolling should start.
Glib::PropertyProxy< Policy > | property_vscroll_policy ()
| Determines when vertical scrolling should start.
Glib::PropertyProxy_ReadOnly< Policy > | property_vscroll_policy () const
| Determines when vertical scrolling should start.

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::ListBase
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::Widget
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static void | set_default_direction (TextDirection dir)
| Sets the default reading direction for widgets.
static TextDirection | get_default_direction ()
| Obtains the current default reading direction.
Static Public Member Functions inherited from Gtk::Accessible
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::Buildable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::ConstraintTarget
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::Orientable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::Scrollable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Related Symbols
(Note that these are not member symbols.)
Gtk::ListView * | wrap (GtkListView * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::ListBase
Gtk::ListBase * | wrap (GtkListBase * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Widget
Gtk::Widget * | wrap (GtkWidget * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Accessible
Glib::RefPtr< Gtk::Accessible > | wrap (GtkAccessible * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Buildable
Glib::RefPtr< Gtk::Buildable > | wrap (GtkBuildable * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::ConstraintTarget
Glib::RefPtr< Gtk::ConstraintTarget > | wrap (GtkConstraintTarget * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Orientable
Glib::RefPtr< Gtk::Orientable > | wrap (GtkOrientable * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Scrollable
Glib::RefPtr< Gtk::Scrollable > | wrap (GtkScrollable * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from Gtk::Widget
using | SlotTick = sigc::slot< bool(const Glib::RefPtr< Gdk::FrameClock > &)>
| Callback type for adding a function to update animations.
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from Gtk::Accessible
enum class | Role { ALERT , ALERT_DIALOG , BANNER , BUTTON , CAPTION , CELL , CHECKBOX , COLUMN_HEADER , COMBO_BOX , COMMAND , COMPOSITE , DIALOG , DOCUMENT , FEED , FORM , GENERIC , GRID , GRID_CELL , GROUP , HEADING , IMG , INPUT , LABEL , LANDMARK , LEGEND , LINK , LIST , LIST_BOX , LIST_ITEM , LOG , MAIN , MARQUEE , MATH , METER , MENU , MENU_BAR , MENU_ITEM , MENU_ITEM_CHECKBOX , MENU_ITEM_RADIO , NAVIGATION , NONE , NOTE , OPTION , PRESENTATION , PROGRESS_BAR , RADIO , RADIO_GROUP , RANGE , REGION , ROW , ROW_GROUP , ROW_HEADER , SCROLLBAR , SEARCH , SEARCH_BOX , SECTION , SECTION_HEAD , SELECT , SEPARATOR , SLIDER , SPIN_BUTTON , STATUS , STRUCTURE , SWITCH , TAB , TABLE , TAB_LIST , TAB_PANEL , TEXT_BOX , TIME , TIMER , TOOLBAR , TOOLTIP , TREE , TREE_GRID , TREE_ITEM , WIDGET , WINDOW , TOGGLE_BUTTON , APPLICATION }
enum class | State { BUSY , CHECKED , DISABLED , EXPANDED , HIDDEN , INVALID , PRESSED , SELECTED , VISITED }
enum class | Property { AUTOCOMPLETE , DESCRIPTION , HAS_POPUP , KEY_SHORTCUTS , LABEL , LEVEL , MODAL , MULTI_LINE , MULTI_SELECTABLE , ORIENTATION , PLACEHOLDER , READ_ONLY , REQUIRED , ROLE_DESCRIPTION , SORT , VALUE_MAX , VALUE_MIN , VALUE_NOW , VALUE_TEXT }
enum class | Relation { ACTIVE_DESCENDANT , COL_COUNT , COL_INDEX , COL_INDEX_TEXT , COL_SPAN , CONTROLS , DESCRIBED_BY , DETAILS , ERROR_MESSAGE , FLOW_TO , LABELLED_BY , OWNS , POS_IN_SET , ROW_COUNT , ROW_INDEX , ROW_INDEX_TEXT , ROW_SPAN , SET_SIZE }
enum class | PlatformState { FOCUSABLE , FOCUSED , ACTIVE }
Public Types inherited from Gtk::Scrollable
enum class | Policy { MINIMUM , NATURAL }
Protected Member Functions inherited from Gtk::Widget
virtual void | root_vfunc ()
virtual void | unroot_vfunc ()
virtual void | size_allocate_vfunc (int width, int height, int baseline)
virtual SizeRequestMode | get_request_mode_vfunc () const
virtual void | measure_vfunc (Orientation orientation, int for_size, int & minimum, int & natural, int & minimum_baseline, int & natural_baseline) const
virtual bool | grab_focus_vfunc ()
virtual void | set_focus_child_vfunc (Widget * child)
| Sets the focused child of widget.
virtual void | compute_expand_vfunc (bool & hexpand_p, bool & vexpand_p)
virtual bool | contains_vfunc (double x, double y) const
virtual void | snapshot_vfunc (const Glib::RefPtr< Gtk::Snapshot > & snapshot)
| Widget ()
void | realize ()
| Creates the GDK resources associated with a widget.
void | unrealize ()
| Causes a widget to be unrealized (frees all GDK resources associated with the widget).
void | realize_if_needed ()
void | set_focus_child (Widget & child)
| Set child as the current focus child of widget.
void | unset_focus_child ()
| Unsets the focus child of the widget.
Widget * | get_focus_child ()
| Returns the current focus child of widget.
const Widget * | get_focus_child () const
| Returns the current focus child of widget.
virtual void | on_show ()
| This is a default handler for the signal signal_show().
virtual void | on_hide ()
| This is a default handler for the signal signal_hide().
virtual void | on_map ()
| This is a default handler for the signal signal_map().
virtual void | on_unmap ()
| This is a default handler for the signal signal_unmap().
virtual void | on_realize ()
| This is a default handler for the signal signal_realize().
virtual void | on_unrealize ()
| This is a default handler for the signal signal_unrealize().
virtual void | on_state_flags_changed (Gtk::StateFlags previous_state_flags)
| This is a default handler for the signal signal_state_flags_changed().
virtual void | on_direction_changed (TextDirection direction)
| This is a default handler for the signal signal_direction_changed().
virtual bool | on_mnemonic_activate (bool group_cycling)
| This is a default handler for the signal signal_mnemonic_activate().
virtual bool | on_query_tooltip (int x, int y, bool keyboard_tooltip, const Glib::RefPtr< Tooltip > & tooltip)
| This is a default handler for the signal signal_query_tooltip().
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)
Protected Member Functions inherited from Gtk::Accessible
| Accessible ()
| You should derive from this class to use it.
Protected Member Functions inherited from Gtk::Buildable
| Buildable ()
| You should derive from this class to use it.
Protected Member Functions inherited from Gtk::ConstraintTarget
| ConstraintTarget ()
| You should derive from this class to use it.
Protected Member Functions inherited from Gtk::Orientable
| Orientable ()
| You should derive from this class to use it.
Protected Member Functions inherited from Gtk::Scrollable
| Scrollable ()
| You should derive from this class to use it.
virtual bool | get_border_vfunc (Border & border) const

## Detailed Description

A widget for displaying lists.

Gtk::ListView is a widget to present a view into a large dynamic list of items.

Gtk::ListView uses its factory to generate one row widget for each visible item and shows them in a linear display, either vertically or horizontally. The property_show_separators() property offers a simple way to display separators between the rows.

Gtk::ListView allows the user to select items according to the selection characteristics of the model. For models that allow multiple selected items, it is possible to turn on rubberband selection, using set_enable_rubberband().

If you need multiple columns with headers, see Gtk::ColumnView.

An example of using Gtk::ListView:

void setup_listitem_cb(const Glib::RefPtr<Gtk::ListItem>& list_item)
{
auto image = Gtk::make_managed<Gtk::Image>();
image->set_icon_size(Gtk::IconSize::LARGE);
list_item->set_child(*image);
}
void bind_listitem_cb(const Glib::RefPtr<Gtk::ListItem>& list_item)
{
auto item = list_item->get_item();
if (auto app_info = std::dynamic_pointer_cast<Gio::AppInfo>(item))
if (auto image = dynamic_cast<Gtk::Image*>(list_item->get_child()))
image->set(app_info->get_icon());
}
void activate_cb(Gtk::ListView* list, guint position)
{
if (auto model = std::dynamic_pointer_cast<Gio::ListModel>(list->get_model()))
{
auto item = model->get_object(position);
if (auto app_info = std::dynamic_pointer_cast<Gio::AppInfo>(item))
app_info->launch(std::vector<Glib::RefPtr<Gio::File>>());
}
}
...
auto factory = Gtk::SignalListItemFactory::create();
factory->signal_setup().connect(sigc::ptr_fun(setup_listitem_cb));
factory->signal_bind().connect(sigc::ptr_fun(bind_listitem_cb));
Glib::RefPtr<Gio::ListModel> model = create_application_list();
auto list = Gtk::make_managed<Gtk::ListView>(
Gtk::SingleSelection::create(model), factory);
list->signal_activate().connect(
sigc::bind<0>(sigc::ptr_fun(activate_cb), list));
scrolled_window.set_child(*list);
std::shared_ptr
std::vector
Gtk::Image
A widget displaying an image.
Definition image.h:64
Gtk::ListView
A widget for displaying lists.
Definition listview.h:118
Gtk::ListView::get_model
Glib::RefPtr< SelectionModel > get_model()
Gets the model that's currently used to read the items displayed.
Gtk::ListView::signal_activate
Glib::SignalProxy< void(guint)> signal_activate()
Gtk::SignalListItemFactory::create
static Glib::RefPtr< SignalListItemFactory > create()
Gtk::SingleSelection::create
static Glib::RefPtr< SingleSelection > create()
Gtk::IconSize::LARGE
@ LARGE
Large size, for example in an icon view.

See also
  Gtk::SelectionModel, Gtk::ColumnView, Gtk::GridView

Since gtkmm 3.98:

## Constructor & Destructor Documentation

## ◆ ListView() [1/3]

Gtk::ListView::ListView | ( | ListView && | src | ) |
| noexcept

## ◆ ListView() [2/3]

Gtk::ListView::ListView | ( | const ListView & |  | ) |
| delete

## ◆ ~ListView()

Gtk::ListView::~ListView | ( |  | ) |
| overridenoexcept

## ◆ ListView() [3/3]

Gtk::ListView::ListView | ( | const Glib::RefPtr< SelectionModel > & | model = `{}`,
|  | const Glib::RefPtr< ListItemFactory > & | factory = `{}`
| ) |  |
| explicit

## Member Function Documentation

## ◆ get_enable_rubberband()

bool Gtk::ListView::get_enable_rubberband | ( |  | ) | const

Returns whether rows can be selected by dragging with the mouse.

Returns
  `true` if rubberband selection is enabled.

## ◆ get_factory() [1/2]

Glib::RefPtr< ListItemFactory > Gtk::ListView::get_factory | ( |  | ) |

Gets the factory that's currently used to populate list items.

Returns
  The factory in use.

## ◆ get_factory() [2/2]

Glib::RefPtr< const ListItemFactory > Gtk::ListView::get_factory | ( |  | ) | const

Gets the factory that's currently used to populate list items.

Returns
  The factory in use.

## ◆ get_header_factory() [1/2]

Glib::RefPtr< ListItemFactory > Gtk::ListView::get_header_factory | ( |  | ) |

Gets the factory that's currently used to populate section headers.

Since gtkmm 4.12:

Returns
  The factory in use.

## ◆ get_header_factory() [2/2]

Glib::RefPtr< const ListItemFactory > Gtk::ListView::get_header_factory | ( |  | ) | const

Gets the factory that's currently used to populate section headers.

Since gtkmm 4.12:

Returns
  The factory in use.

## ◆ get_model() [1/2]

Glib::RefPtr< SelectionModel > Gtk::ListView::get_model | ( |  | ) |

Gets the model that's currently used to read the items displayed.

Returns
  The model in use.

## ◆ get_model() [2/2]

Glib::RefPtr< const SelectionModel > Gtk::ListView::get_model | ( |  | ) | const

Gets the model that's currently used to read the items displayed.

Returns
  The model in use.

## ◆ get_show_separators()

bool Gtk::ListView::get_show_separators | ( |  | ) | const

Returns whether the list box should show separators between rows.

Returns
  `true` if the list box shows separators.

## ◆ get_single_click_activate()

bool Gtk::ListView::get_single_click_activate | ( |  | ) | const

Returns whether rows will be activated on single click and selected on hover.

Returns
  `true` if rows are activated on single click.

## ◆ get_tab_behavior()

ListTabBehavior Gtk::ListView::get_tab_behavior | ( |  | ) | const

Gets the behavior set for the `Tab` key.

Since gtkmm 4.12:

Returns
  The behavior of the `Tab` key.

## ◆ get_type()

static GType Gtk::ListView::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkListView * Gtk::ListView::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkListView * Gtk::ListView::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ operator=() [1/2]

ListView & Gtk::ListView::operator= | ( | const ListView & |  | ) |
| delete

## ◆ operator=() [2/2]

ListView & Gtk::ListView::operator= | ( | ListView && | src | ) |
| noexcept

## ◆ property_enable_rubberband() [1/2]

Glib::PropertyProxy< bool > Gtk::ListView::property_enable_rubberband | ( |  | ) |

Allow rubberband selection.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_enable_rubberband() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::ListView::property_enable_rubberband | ( |  | ) | const

Allow rubberband selection.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_factory() [1/2]

Glib::PropertyProxy< Glib::RefPtr< ListItemFactory > > Gtk::ListView::property_factory | ( |  | ) |

Factory for populating list items.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_factory() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< ListItemFactory > > Gtk::ListView::property_factory | ( |  | ) | const

Factory for populating list items.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_header_factory() [1/2]

Glib::PropertyProxy< Glib::RefPtr< ListItemFactory > > Gtk::ListView::property_header_factory | ( |  | ) |

Factory for creating header widgets.

Since gtkmm 4.12:

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_header_factory() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< ListItemFactory > > Gtk::ListView::property_header_factory | ( |  | ) | const

Factory for creating header widgets.

Since gtkmm 4.12:

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_model() [1/2]

Glib::PropertyProxy< Glib::RefPtr< SelectionModel > > Gtk::ListView::property_model | ( |  | ) |

Model for the items displayed.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_model() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< SelectionModel > > Gtk::ListView::property_model | ( |  | ) | const

Model for the items displayed.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_show_separators() [1/2]

Glib::PropertyProxy< bool > Gtk::ListView::property_show_separators | ( |  | ) |

Show separators between rows.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_show_separators() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::ListView::property_show_separators | ( |  | ) | const

Show separators between rows.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_single_click_activate() [1/2]

Glib::PropertyProxy< bool > Gtk::ListView::property_single_click_activate | ( |  | ) |

Activate rows on single click and select them on hover.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_single_click_activate() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::ListView::property_single_click_activate | ( |  | ) | const

Activate rows on single click and select them on hover.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_tab_behavior() [1/2]

Glib::PropertyProxy< ListTabBehavior > Gtk::ListView::property_tab_behavior | ( |  | ) |

Behavior of the `Tab` key.

Since gtkmm 4.12:

Default value: Gtk::ListTabBehavior::ALL

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_tab_behavior() [2/2]

Glib::PropertyProxy_ReadOnly< ListTabBehavior > Gtk::ListView::property_tab_behavior | ( |  | ) | const

Behavior of the `Tab` key.

Since gtkmm 4.12:

Default value: Gtk::ListTabBehavior::ALL

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ scroll_to()

void Gtk::ListView::scroll_to | ( | guint | pos,
|  | ListScrollFlags | flags,
|  | const Glib::RefPtr< const ScrollInfo > & | scroll
| ) |  |

Scrolls to the item at the given position and performs the actions specified in flags.

This function works no matter if the listview is shown or focused. If it isn't, then the changes will take effect once that happens.

Since gtkmm 4.12:

Parameters

  pos | Position of the item.
  flags | Actions to perform.
  scroll | Details of how to perform the scroll operation or `nullptr` to scroll into view.

## ◆ set_enable_rubberband()

void Gtk::ListView::set_enable_rubberband | ( | bool | enable_rubberband = `true` | ) |

Sets whether selections can be changed by dragging with the mouse.

Parameters

  enable_rubberband | `true` to enable rubberband selection.

## ◆ set_factory()

void Gtk::ListView::set_factory | ( | const Glib::RefPtr< ListItemFactory > & | factory | ) |

Sets the `Gtk::ListItemFactory` to use for populating list items.

Parameters

  factory | The factory to use.

## ◆ set_header_factory()

void Gtk::ListView::set_header_factory | ( | const Glib::RefPtr< ListItemFactory > & | factory | ) |

Sets the `Gtk::ListItemFactory` to use for populating the Gtk::ListHeader objects used in section headers.

If this factory is set to `nullptr`, the list will not show section headers.

Since gtkmm 4.12:

Parameters

  factory | The factory to use.

## ◆ set_model()

void Gtk::ListView::set_model | ( | const Glib::RefPtr< SelectionModel > & | model | ) |

Sets the model to use.

This must be a Gtk::SelectionModel to use.

Parameters

  model | The model to use.

## ◆ set_show_separators()

void Gtk::ListView::set_show_separators | ( | bool | show_separators = `true` | ) |

Sets whether the list box should show separators between rows.

Parameters

  show_separators | `true` to show separators.

## ◆ set_single_click_activate()

void Gtk::ListView::set_single_click_activate | ( | bool | single_click_activate = `true` | ) |

Sets whether rows should be activated on single click and selected on hover.

Parameters

  single_click_activate | `true` to activate items on single click.

## ◆ set_tab_behavior()

void Gtk::ListView::set_tab_behavior | ( | ListTabBehavior | tab_behavior | ) |

Sets the behavior of the `Tab` and `Shift`+`Tab` keys.

Since gtkmm 4.12:

Parameters

  tab_behavior | The desired tab behavior.

## ◆ signal_activate()

Glib::SignalProxy< void(guint)> Gtk::ListView::signal_activate | ( |  | ) |

Slot Prototype:
  `void on_my_activate(guint position)`

Flags: Run Last

Emitted when a row has been activated by the user, usually via activating the GtkListView|list.activate-item action.

This allows for a convenient way to handle activation in a listview. See Gtk::ListItem::set_activatable() for details on how to use this signal.

Parameters

  position | Position of item to activate.

## Friends And Related Symbol Documentation

## ◆ wrap()

Gtk::ListView * wrap | ( | GtkListView * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.